import java.applet.*;
import java.awt.*;
import java.awt.image.*;
import java.util.*;
import java.util.zip.*;
import java.io.*;
import java.net.*;

public class CGISaveManager extends SaveManager implements Runnable {
    DesignCanvas myCanvas;
    Color myBackground;
    GZIPOutputStream os;
    URL uBase;
    String uCgi;
    URL url;
    URLConnection uc;
    String urlBasisStr;
    String codeStr;
    Thread myThread;

    public boolean setURL(URL base, String cgiurl) {
	uBase = base;
	uCgi = cgiurl;
	return true;
    }

    public URL getCGIURL() {
	try {
	    if (uCgi == null)
		url = uBase;
	    else 
		url = new URL(uBase, uCgi);
	}
	catch (Exception e) { 
	    System.out.println("Exception at line 32: " + e);
	    return null; 
	}

	try {
	    urlBasisStr = url.toString();
	    codeStr = "1" + System.currentTimeMillis() + ((int)(Math.random() * 2000));
	    String s2 = urlBasisStr + "?put=" + codeStr;
	    url = new URL(s2);
	}
	catch (Exception e) { 
	    System.out.println("Exception at line 43: " + e);
	    return null;}

	return url;
    }

    public void performSave(DesignCanvas dc, Color bg) {
	getDesigns(dc);
	if (designs == null || designs.length == 0) {
	    setChanged();
	    notifyObservers("No designs drawn; not saving.");
	    return;
	}
	myCanvas = dc;
	myBackground = bg;
	myThread = new Thread(this);
	myThread.start();
	setChanged(); notifyObservers("Starting save..");
    }

    public String formatMessage(Object arg) {
	if (arg instanceof Integer) {
	    return "CGI Web Save: " + arg.toString() + " bytes sent.";
	}
	else {
	    return "CGI Web Save: " + arg.toString();
	}

    }

    public void run() {
	int code;

	try {
	    // do setup
	    Thread.sleep(200);
	    URL u1 = getCGIURL();
	    setChanged(); notifyObservers("Connecting to " + u1.toString() + "..");
	    uc = u1.openConnection();
	    uc.setDoOutput(true);
	    uc.setDoInput(true);
	    uc.setUseCaches(false);
	    OutputStream os = uc.getOutputStream();


	    // send data 
	    Thread.sleep(200); 
	    setChanged(); notifyObservers("Sending..");
	    String urlstr = uc.getURL().getFile();
	    GZIPOutputStream gzos = new GZIPOutputStream(os);
	    myCanvas.writeData(designs, gzos, myBackground, DesignCanvas.FORMAT_PPM);
	    // writeData will flush but not close the stream
	    gzos.finish();
	    setChanged(); notifyObservers("Data sent, getting response..");
	}
	catch (Exception ie) {
	    setChanged();
	    notifyObservers("Upload failed: " + ie);
	    return;
	}

	try {    Thread.sleep(200); } catch (InterruptedException ie2) { }
	try {
	    // get response, doesnt matter if this fails
	    // if (uc instanceof HttpURLConnection) {
	    // code = ((HttpURLConnection)uc).getResponseCode();
	    //	setChanged(); notifyObservers("Response code is: " + code);
	    // 	System.out.println("Response code is: " + code);
	    // }
	    // else {

	    Object conn = uc.getContent();
	    // System.out.println("Okay, content is: " + conn);
	    if (conn instanceof InputStream) {
		((InputStream)conn).read(new byte[4096]);
		((InputStream)conn).close();
	    }

	    // }
	    // System.out.println("finished with getting content.");
	    // close connection
	    setChanged(); notifyObservers("Done.");
	    // if (uc instanceof HttpURLConnection)
	    // 	((HttpURLConnection)uc).disconnect();
	}
	catch (Exception e) { }

	// send web browser to that page
	try { Thread.sleep(200); } catch (InterruptedException ie3) { }
	setChanged(); notifyObservers("Spawning browser window.");
	try {
	    String s3 = urlBasisStr + "?page=" + codeStr;
	    URL u3 = new URL(s3);
	    try { Thread.sleep(200); } catch (InterruptedException ie5) { }
	    setChanged(); notifyObservers(u3);
	}
	catch (MalformedURLException mue) {
	    setChanged(); notifyObservers("Problem with URL: " + mue);
	}
	return;
    }
}

