
/**
 * This class represents a circular moving
 * part of a spirograph rendering.
 */

public class CircleMobile extends Mobile
{
    public CircleMobile(double s, double pr) {
	super(s, pr);
    }

    public double angleToDistance(double phi) {
	return (phi * radius);
    }

    public double distanceToAngle(double d) {
	return (d / radius);
    }

    /**
     * Given a point on the perimeter of the circle, and
     * the normal angle at the point where this Mobile
     * is touching the stabile, and the distance rolled
     * by the Mobile, compute the ppoint location of the
     * pen and return it.
     */
    public void findPen(PPoint pp, double norm, double dist, boolean inside,
			PPoint result) 
    {
	double centerx = pp.x + radius * Math.cos(norm);
	double centery = pp.y + radius * Math.sin(norm);

	double ca;
	if (inside)
	    ca = distanceToAngle(dist) + Math.PI + norm;
	else
	    ca = distanceToAngle(dist) + norm;  // ORIG
	
	result.x = centerx + penRadius * Math.cos(ca);
	result.y = centery + penRadius * Math.sin(ca);
    }

    public String toString() {
        return "CircleMobile[r=" + radius + ", pr=" + penRadius + "]";
    }

}



