
public class CircleStabile extends Stabile
{
    protected double radius;

    /**
     * Create a CircleStabile at center point c and
     * with radius r.
     */
    public CircleStabile(PPoint c, double r) {
	super(c);
	radius = r;
    }

    public double angleToDistance(double phi) {
	return (phi * radius);
    }

    public double distanceToAngle(double d) {
	return (d / radius);
    }

    public double distanceToNormal(double dist, boolean inside) {
	double a = distanceToAngle(dist);
	// int fr = (int)(a / (2.0 * Math.PI));
	// if (fr > 0) a -= (fr * 2 * Math.PI);
	if (inside) a += Math.PI;
	return a;
    }
    
    public PPoint distanceToPoint(double dist) {
	double a = distanceToAngle(dist);
	return new PPoint(center, 
			  radius * Math.cos(a), 
			  radius * Math.sin(a));
    }

    public String toString() {
        return "CircleStabile[c=" + center + ", rad=" + radius + "]";
    }

}


