public class PPoint {
    public double x;
    public double y;

    public PPoint(double _x, double _y) {
	x = _x; y = _y;
    }

    public PPoint(PPoint basis, double tx, double ty) {
	x = basis.x + tx;
	y = basis.y + ty;
    }

    public PPoint() { x = 0.0; y = 0.0; }

    public PPoint translate(double byX, double byY) {
	return new PPoint(x + byX, y + byY);
    }

    public final double distanceTo(PPoint that) {
	return Math.sqrt((this.x - that.x) * (this.x - that.x) +
			 (this.y - that.y) * (this.y - that.y));
    }

    public String toString() {
	return "PP[" + x + "," + y + "]";
    }
}
