import java.awt.*;

/**
 * This interface defines two methods that both the
 * stationary and moving parts of a spirograph
 * rendering need to be able to implement: 1. given
 * an angle around the shape, compute the distance
 * around the perimeter (rolling distance), and 2.
 * given a distance around the perimeter, compute
 * the angle relative to the center.
 */
public interface PShape {
    double angleToDistance(double phi);
    double distanceToAngle(double d);
}

