/**
 * This abstract class is the basis for the stationary
 * part of a spirograph rendering.  It has to be able
 * to do several things: 1. Accept a center point,
 * 2. given a distance around its perimeter, return the
 * normal angle, outside or inside, 3. given a distance
 * around the perimeter, return a point on the perimeter.
 * <p>
 * Stabile also implements PShape, which means it has
 * to be able to do some additional computations.
 * @see PShape
 */

public abstract class Stabile implements PShape {
    protected PPoint center;

    public Stabile(PPoint c) {
	center = c;
    }
    public PPoint getCenter() { return center; }
    
    public abstract double distanceToNormal(double dist, boolean inside);
    public abstract PPoint distanceToPoint(double dist);
}


